<?php

/*
Plugin Name: Peter's Date Countdown
Plugin URI: http://www.theblog.ca
Description: Display a countdown of important dates
Version: 1.3
Author: Peter Keung
Author URI: http://www.theblog.ca/?p=41
Change Log:
2006-08-10  The first version.
2006-08-14  New feature: sort the countdowns by date. Also, tweaked rounding of dates.
2006-08-26  New option to tweak the countdown time if your server time is different from your time
2006-09-01  New options where you can count down to the exact hour or minute when the time remaining is less than one day and also to limit the number of countdowns to show at once.
*/

// Change this if you want to add or subtract hours from your server time
$timediff = 0;

// Change this to equal 1 if you want the countdown to display the number of hours remaining when there is less than one day remaining
$showhours = 0;

// Change this to equal 1 if you want the countdown to display the number of minutes remaining when there is less than one hour remaining
$showminutes = 0;

// Change this to equal the maximum number of countdowns to display at once. For an unlimited number of countdowns, make it equal 0
$numcountdowns = 0;

// You shouldn't have to edit below this line!

function countdown_manage() {
global $timediff;
if (isset($_GET['sort'])) {
require "../wp-content/plugins/datecountdowndates.php";
$howmanydates = count($importantdate);
for ($i = 0; $i < $howmanydates; $i = $i + 1) {
$month = $importantdate[$i][1] + 0;
$day = $importantdate[$i][2] + 0;
$year = $importantdate[$i][3] + 0;
$hour = $importantdate[$i][5] + 0;
$minute = $importantdate[$i][6] + 0;
$importantdate[$i]['date'] = mktime($hour,$minute,0,$month,$day,$year);
}
function cmp ($a, $b) {
if ( $a['date'] < $b['date'] ) {
return -1;
}
if ( $a['date'] > $b['date'] ) {
return 1;
}
return 0;
}
usort($importantdate, "cmp");
$line[] = "<?";
$i = 0;
while ($i < $howmanydates) {
$itemname = $importantdate[$i][0];
$itemday = $importantdate[$i][2] + 0;
$itemmonth = $importantdate[$i][1] + 0;
$itemyear = $importantdate[$i][3] + 0;
$itemfinished = $importantdate[$i][4];
$itemhour = $importantdate[$i][5] + 0;
$itemminute = $importantdate[$i][6] + 0;
$line[] = "$" . "importantdate[$i]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\", $itemhour, $itemminute);";
++$i;
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../wp-content/plugins/datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
}
if (isset($_GET['deletedate'])) {
$goback = $_SERVER['HTTP_REFERER'];
require "../wp-content/plugins/datecountdowndates.php";
$line[] = "<?";
$howmanydates = count($importantdate);
$modi = 0;
for ($i = 0; $i < $howmanydates; $i = $i + 1) {
if ($i == $_GET['deletedate']) {
continue;
}
$itemname = $importantdate[$i][0];
$itemmonth = $importantdate[$i][1] + 0;
$itemday = $importantdate[$i][2] + 0;
$itemyear = $importantdate[$i][3] + 0;
$itemfinished = $importantdate[$i][4];
$itemhour = $importantdate[$i][5] + 0;
$itemminute = $importantdate[$i][6] + 0;
$line[] = "$" . "importantdate[$modi]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\", $itemhour, $itemminute);";
$modi = $modi + 1;
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../wp-content/plugins/datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
print "<div class=\"wrap\">\n<p>Date deleted!</p>\n<p><a href=\"$goback\">Back</a><p>\n</div>";
}
else {
if ($_POST['submit']) {
$line[] = "<?";
$howmanydates = count($_POST['itemname']);
$i = 0;
while ($i < $howmanydates) {
$itemname = $_POST['itemname'][$i];
$itemday = $_POST['itemday'][$i] + 0;
$itemmonth = $_POST['itemmonth'][$i] + 0;
$itemyear = $_POST['itemyear'][$i] + 0;
$itemfinished = $_POST['itemfinished'][$i];
$itemhour = $_POST['itemhour'][$i] + 0;
$itemminute = $_POST['itemminute'][$i] + 0;
$line[] = "$" . "importantdate[$i]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\", $itemhour, $itemminute);";
++$i;
if ($i + 1 == $howmanydates) {
if ($_POST['itemname'][$i] == "" or $_POST['itemday'][$i] == "" or $_POST['itemmonth'][$i] == "" or $_POST['itemyear'][$i] == "")
break;
}
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../wp-content/plugins/datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
}
require "../wp-content/plugins/datecountdowndates.php";
	?>
	<div class="wrap">
	<h2>Date Countdown</h2>
<p>Server date/time: <? print date('r'); ?></p>
<p>Script offset: <? print $timediff; ?></p>
<p>Script date/time: <? print date('r', time() + $timediff * 3600); ?> (<em>edit the plugin file to change this</em>)</p>
<h3>Current Countdowns:</h3>
<p><strong><a href="<? print $_SERVER['PHP_SELF']; ?>?page=datecountdown.php&sort">Sort by date, ascending</a></strong></p>
<p><font color="red">Note: to delete an item, click on the red X, or simply replace the info with a new item!</font></p>
<form name="currentcountdowns" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?page=datecountdown.php">
<?
$howmanydates = count($importantdate);
$i = 0;
while ($i < $howmanydates) {
?>
<p><strong><a href="<? print $_SERVER['PHP_SELF']; ?>?page=datecountdown.php&deletedate=<? print $i; ?>"><font color="red">X</font></a></strong>&nbsp;&nbsp;Name: <input type="text" name="<? print "itemname[$i]"; ?>" size="30" maxlength="45" value="<? print stripslashes($importantdate[$i][0]); ?>" /><br />Month: <input type="text" name="<? print "itemmonth[$i]"; ?>" size="2" maxlength="2" value="<? print $importantdate[$i][1]; ?>" /> Day: <input type="text" name="<? print "itemday[$i]"; ?>" size="2" maxlength="2" value="<? print $importantdate[$i][2]; ?>" /> Year: <input type="text" name="<? print "itemyear[$i]"; ?>" size="4" maxlength="4" value="<? print $importantdate[$i][3]; ?>" /> Hour (24hr): <input type="text" name="<? print "itemhour[$i]"; ?>" size="2" maxlength="2" value="<? print $importantdate[$i][5]; ?>" /> Minute: <input type="text" name="<? print "itemminute[$i]"; ?>" size="2" maxlength="2" value="<? print $importantdate[$i][6]; ?>" /><br />Text when finished: <input type="text" name="<? print "itemfinished[$i]"; ?>" size="30" maxlength="45" value="<? print stripslashes($importantdate[$i][4]); ?>" /></p> 
	<?php
++$i;
}
?>
<h3>Add a new countdown</h3>
<p>Name: <input type="text" name="<? print "itemname[$i]"; ?>" size="30" maxlength="30" /><br />Month: <input type="text" name="<? print "itemmonth[$i]"; ?>" size="2" maxlength="2" /> Day: <input type="text" name="<? print "itemday[$i]"; ?>" size="2" maxlength="2" /> Year: <input type="text" name="<? print "itemyear[$i]"; ?>" size="4" maxlength="4" /> Hour (24hr): <input type="text" name="<? print "itemhour[$i]"; ?>" size="2" maxlength="2" /> Minute: <input type="text" name="<? print "itemminute[$i]"; ?>" size="2" maxlength="2" /><br />Text when finished: <input type="text" name="<? print "itemfinished[$i]"; ?>" size="30" maxlength="30" /></p>
<input name="submit" type="submit" value="Update" />
<?
}
}

function countdown_callit() {
global $timediff, $showhours, $showminutes, $numcountdowns;
require "wp-content/plugins/datecountdowndates.php";
$howmanydates = count($importantdate);
if ($numcountdowns > 0 && $howmanydates > $numcountdowns) {
$howmanydates = $numcountdowns;
}
$i = 0;
while ($i < $howmanydates) {
countdown_execute(stripslashes($importantdate[$i][0]), $importantdate[$i][1], $importantdate[$i][2], $importantdate[$i][3], stripslashes($importantdate[$i][4]), $timediff, $importantdate[$i][5], $importantdate[$i][6], $showhours, $showminutes);
++$i;
}
}

function countdown_execute($event,$month,$day,$year,$finished,$timediff,$hour,$minute,$showhours,$showminutes) {
// subtract desired date from current date and give an answer in terms of days
$remain = mktime($hour,$minute,0,$month,$day,$year) - (time() + $timediff * 3600);
// show the number of days left
if ($remain < 0) {
// if the event has arrived, say so!
print "<p>$finished</p>\n";
}
elseif ($remain < 3600 && $showminutes == 1) {
// show the number of minutes remaining
$remain = ceil($remain / 60);
if ($remain == 1) {
print "<p><strong>$remain</strong> more minute until $event</p>\n";
}
else {
print "<p><strong>$remain</strong> more minutes until $event</p>\n";
}
}
elseif ($remain < 86400 && $showhours == 1) {
// show the number of hours remaining
if ($showminutes <> 1) {
$remain = ceil($remain / 3600);
}
else {
$remain = round($remain / 3600);
}
if ($remain == 1) {
print "<p><strong>$remain</strong> more hour until $event</p>\n";
}
else {
print "<p><strong>$remain</strong> more hours until $event</p>\n";
}
}
else {
if ($showhours <> 1) {
$remain = ceil($remain / 86400);
}
else {
$remain = round($remain / 86400);
}
if ($remain == 1) {
print "<p><strong>$remain</strong> more sleep until $event</p>\n";
}
else {
print "<p><strong>$remain</strong> more sleeps until $event</p>\n";
}
}
}

function datecountdown_adminmenu(){
	add_management_page('Date Countdown', 'Date Countdown', 9, 'datecountdown.php', 'countdown_manage');
}

add_action('admin_menu','datecountdown_adminmenu',1);
?>